'' =================================================================================================
''
''   File....... jm_vixen_demo.spin
''   Purpose.... Eight channel lighting controller for Vixen
''   Author..... Jon "JonnyMac" McPhalen 
''               Copyright (c) 2011 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 07 NOV 2011
''
'' =================================================================================================

{{

  In Vixen use the Generic Serial driver with no header or footer, transmitted at 57.6K

  Set the Event Period to 25ms for smooth fades.

  Using 57.6K and a 25ms period you can dim up to 104 channels -- more than can be supported
  using the 8-channel LED object in 6 cogs.  That driver can be updated to 16 channels but at
  a reduced modulation frequency and perhaps flickering  at some levels.

}}


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1  = 31
  TX1  = 30
  SDA  = 29
  SCL  = 28

  LED8 = 23                                                     ' demo board / quickstart bd
  LED7 = 22
  LED6 = 21
  LED5 = 20
  LED4 = 19
  LED3 = 18
  LED2 = 17
  LED1 = 16


obj

  serial : "fullduplexserial"
  leds1  : "jm_led8"
' leds2  : "jm_led8"


var


pub main | c, idx 

  serial.start(RX1, TX1, %0000, 57_600)                         ' for Vixen Generic Serial driver
  leds1.start(8, LED1)                                          ' LED dimmer(s)
' leds2.start(8, LED9)
  pause(1)

  repeat
    repeat
      c := serial.rxtime(5)                                     ' wait for 5ms idle period
    until (c == -1)

    repeat idx from 0 to 7                                      ' rx eight channel levels
      leds1.set(idx, serial.rx)

'   repeat idx from 0 to 7                                      ' rx next eight channel levels
'     leds2.set(idx, serial.rx)



pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)


dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}